{-------------------------------------------------------------------------------
Exemple - Extension du menu contextuel d'Internet Explorer
Adrien Montfaucon

- Mises  jour : http://www.phidels.com / http://admon.free.fr

- Erreurs, Questions, suggestions : am-vector@laposte.net
-------------------------------------------------------------------------------}

unit MyDownload_Host;

{-------------------------------------------------------------------------------
Extension du menu contextuel d'Internet Explorer

Unit princupale du serveur COM
-------------------------------------------------------------------------------}

{$WARN SYMBOL_PLATFORM OFF}

interface

uses
  ComObj, MyDownload_ComHost_TLB, Windows, ShellApi, Registry, StdVcl,
  MyDownload_CommonConsts; //Ne pas oublier l'unit de constantes communes

type
  TMyDownload = class(TAutoObject, IMyDownload)
  protected
    procedure AddUrl(const URL, Title: WideString); safecall;
  end;

implementation

uses ComServ;

{ TMyDownload }

procedure TMyDownload.AddUrl(const URL, Title: WideString);
var DownloadHandle: HWND;
    NewURL, NewTitle, Path: String;
    Registry: TRegistry;
begin
NewURL:=URL;
NewTitle:=Title;
//Dtermine si l'application rsidente est active
DownloadHandle:=FindWindow(HostClass,nil);
if DownloadHandle=0 then
  begin
  //Cherche l'emplacement de l'application rsidente
  Registry:=TRegistry.Create(KEY_READ);
  with Registry do
    try
      RootKey:=HKEY_LOCAL_MACHINE;
      OpenKey('Software\'+HostpathKey, False);
      Path:=ReadString('');
    finally
      Free;
    end;
  //Dmarre l'application
  ShellExecute(0, 'Open', PChar(Path), PChar('"'+NewURL+'" "'+NewTitle+'"'), nil, SW_SHOWNORMAL)
  end
else
  //Si l'application est dj ouverte, on lui envoie un message
  PostMessage(DownloadHandle, RegisterWindowMessage(HostMessage), GlobalAddAtom(PChar(NewUrl)) ,GlobalAddAtom(PChar(NewTitle)));
end;

initialization
  TAutoObjectFactory.Create(ComServer, TMyDownload, Class_MyDownload,
    ciSingleInstance, tmSingle);
end.
